EyeCandy = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "CandyBar-2.0")

function EyeCandy:OnInitialize()
        local args = {
                type="group",
                args = {
                        test = {
                                name = "Test the eye candy", type = "execute",
                                desc = "Tests the eye candy",
                                func = function() EyeCandy:Test() end,
                        },
                        pause = {
                                name = "Pause the eye candy bar", type = "execute",
                                desc = "Pauses the eye candy bar",
                                func = function() EyeCandy:Pause() end,
                        },
                }
        }

        self:RegisterChatCommand({ "/eyecandy" }, args )
end

local function EyeCandy_Formatting( t)
	return string.format("%02d", floor(t))
end

function EyeCandy:Test()
	self:RegisterCandyBar("CandyBar 1", 10, "CandyBar 1", "Interface\\Icons\\Spell_Shadow_PsychicScream", "yellow", "blue", "red")
	self:RegisterCandyBar("CandyBar 2", 20, "Bar 2 is here", "Interface\\Icons\\Spell_Shadow_PsychicScream", "green", "blue", "red", "white", "yellow")
	self:RegisterCandyBar("CandyBar 3", 30, "Bar 3", "Interface\\Icons\\Spell_Shadow_PsychicScream", "red", "white", "purple")
	self:RegisterCandyBar("CandyBar 4", 40, "bar 4", "Interface\\Icons\\Spell_Shadow_PsychicScream", "green", "orange", "blue", "red")
	
	self:RegisterCandyBarGroup("Frop")
	self:SetCandyBarGroupGrowth( "Frop", true ) -- grow up

	self:RegisterCandyBarWithGroup("CandyBar 1", "Frop")
	self:RegisterCandyBarWithGroup("CandyBar 2", "Frop")
	self:RegisterCandyBarWithGroup("CandyBar 3", "Frop")
	self:RegisterCandyBarWithGroup("CandyBar 4", "Frop")
	
	self:SetCandyBarColor("CandyBar 1", "Red", 0.5)
	
	self:SetCandyBarTimeFormat("CandyBar 1", EyeCandy_Formatting)

	self:SetCandyBarFade("CandyBar 1", .5)
	self:SetCandyBarFade("CandyBar 2", .5)

	self:SetCandyBarOnClick( "CandyBar 1", function(name, button, extra) self:Print( name .." "..button.." "..extra) end, "zomg" )
	self:SetCandyBarOnClick( "CandyBar 2", function(name, button, extra) self:Print( name .." "..button.." "..extra) end, "amazing" )
	self:SetCandyBarOnClick( "CandyBar 3", function(name, button, extra) self:Print( name .." "..button.." "..extra) end, "it works" )
	self:SetCandyBarOnClick( "CandyBar 4", function(name, button, extra) self:Print( name .." "..button.." "..extra) end, "yeah baby" )
		
	self:StartCandyBar("CandyBar 1")
	self:StartCandyBar("CandyBar 2")
	self:StartCandyBar("CandyBar 3")
	self:StartCandyBar("CandyBar 4")
end

function EyeCandy:Pause()
	local r, t, e, u
	if not self.paused then
		r, t, e, u = self:CandyBarStatus("CandyBar 2")
		self:Print( tostring(r) .. "   " .. tostring(t) .. "   " .. tostring( e) .. "   " .. tostring(u) )
		self:PauseCandyBar("CandyBar 2")
		r, t, e, u = self:CandyBarStatus("CandyBar 2")
		self:Print( tostring(r) .. "   " .. tostring(t) .. "   " .. tostring( e) .. "   " .. tostring(u) )
		self.paused = true
	else
		r, t, e, u = self:CandyBarStatus("CandyBar 2")
		self:Print( tostring(r) .. "   " .. tostring(t) .. "   " .. tostring( e) .. "   " .. tostring(u) )
		self:StartCandyBar("CandyBar 2")
		r, t, e, u = self:CandyBarStatus("CandyBar 2")
		self:Print( tostring(r) .. "   " .. tostring(t) .. "   " .. tostring( e) .. "   " .. tostring(u) )
		self.paused = nil
	end

end
